{**************************************}
{ Copyright (C) MarinovSoft 2000-2006  }
{ http://marinovsoft.narod.ru          }
{ super386@rambler.ru                  }
{**************************************}
Unit PCXUnit;
Interface
Uses BMPUnit,Graph;
Type
  Pcxheader_Rec=Record
    Manufacturer: Byte;
    Version: Byte;
    Encoding: Byte;
    Bits_Per_Pixel: Byte;
    Xmin, Ymin: Word;
    Xmax, Ymax: Word;
    Hres: Word;
    Vres: Word;
    Palette: Array [0..47] Of Byte;
    Reserved: Byte;
    Colour_Planes: Byte;
    Bytes_Per_Line: Word;
    Palette_Type: Word;
    Filler: Array [0..57] Of Byte;
  End;
Type
  Ppcx = ^Tpcx;
  Tpcx = Object(TBitmap)
    Constructor Init(FileName:String);
  End;
Implementation
Var
  Header: Pcxheader_Rec;
  Width, Depth: Word;
  Bytes: Word;
  Palette: Array [0..767] Of Byte;
  C: Byte;
  Colorarray:Array[0..255] Of LongInt;

Procedure FatalExit;
Begin
  CloseGraph;
  WriteLn('Fatal Error!');
  Halt;
End;

Constructor Tpcx.Init;
Procedure Read_Pcx_Line(Vidoffset1: Word);
Var C, Run: Byte;
  N: Integer;
  W: Word;
  Vidoffset:Word;
Begin
  N:=0;Vidoffset:=0;
  While (N < Bytes) Do
  Begin
    BlockRead (F, C, 1);
    If ((C And 192)=192) Then
    Begin
      Run:=C And 63;
      BlockRead (F, C, 1);
      N:=N+Run;
      For W:=0 To Run-1 Do
      Begin
        Scrarray^[Vidoffset,Vidoffset1]:=Colorarray[C];
        Inc(Vidoffset);
      End;
    End Else
    Begin
      Inc(N,1);
      Scrarray^[Vidoffset,Vidoffset1]:=Colorarray[C];
      Inc(Vidoffset);
    End;
  End;
End;
Procedure Unpack_Pcx_File;
Var I: Integer;
Begin
  I:=0;
  While I<768 Do
  Begin
    Colorarray[I Div 3]:=Palette[I]ShL 16+Palette[I+1]ShL 8+Palette[I+2];
    Inc(I,3);
  End;
  For I:=1 To Depth Do
    Read_Pcx_Line (I);
End;
Begin
  New(Scrarray);
  Assign(F,FileName);
  Reset(F,1);
  BlockRead (F, Header, SizeOf (Header));
  If (Header.Manufacturer=10) And (Header.Version=5) And
     (Header.Bits_Per_Pixel=8) And (Header.Colour_Planes=1) Then
  Begin
    Seek (F, FileSize (F)-769);
    BlockRead (F, C, 1);
    If (C=12) Then
    Begin
      BlockRead (F, Palette, 768);
      Seek (F, 128);
      Width:=Header.Xmax-Header.Xmin;
      Depth:=Header.Ymax-Header.Ymin+1;
      Bytes:=Header.Bytes_Per_Line;
      Unpack_Pcx_File;
      Xx:=Width;
        Yy:=Depth;
      End Else FatalExit;
      End
      Else FatalExit;
    Close (F);
End;
End.